console.log("Usual worflow script included.");

// Usual Workflownamespace
UWF = {};
UWF.ALL_STATES = ['new', 'in_design', 'in_progress',
                  'for_code_review', 'in_code_review', 'for_merge',
                  'for_test', 'deployed_on_test', 'for_test_review',
                  'closed', 'reopened'];
UWF.TRAC_STATUS_CSS_CLASS_PREFIX = 'action_';
UWF.ANIM_SPEED = 250;  // speed of show/hide animation

// attribute name is source state, value is array of names of states which
// usually follow after the source state
UWF.USUAL_WORKFLOW = {
    new: ['in_design', 'in_progress', 'closed'],
    in_design: ['in_progress'],
    in_progress: ['for_code_review', 'for_test'],
    for_code_review: ['in_code_review'],
    in_code_review: ['for_merge'],
    for_merge: ['for_test'],
    for_test: ['deployed_on_test', 'closed'],
    deployed_on_test: ['for_test_review', 'reopen', 'closed'],
    for_test_review: ['reopened', 'closed'],
    closed: ['reopened'],
    reopened: ['in_progress', 'closed'],
};

UWF.getCssName = function (status) {
    return UWF.TRAC_STATUS_CSS_CLASS_PREFIX + status;
};

UWF.init = function () {
    // set "leave as ..." to be checked at start
    $('#action input[id^="action_leave"]').prop("checked", true);

    // get name of current state from the leave radiobutton
    UWF.currentState = $('#action input[id^="action_leave"]').prop('id').slice("action_leave_as_".length);
    console.log('Current state is ' + UWF.currentState);

    UWF.currentUsualStates = UWF.USUAL_WORKFLOW[UWF.currentState];
    UWF.currentUnusualStates = UWF.ALL_STATES.filter(function (state) {
        return UWF.currentUsualStates.indexOf(state) == -1;
    });

    UWF.hideUnusualStates();
    UWF.addSwitch();
};

UWF.hideUnusualStates = function (doAnim) {
    var animLength = false;
    if (doAnim) {
        animLength = UWF.ANIM_SPEED;
    }
    UWF.currentUnusualStates.forEach(function (state) {
        // hide unusual states that are not checked
        $('#' + UWF.getCssName(state) + ':not(:checked)').parent().hide(animLength);
    });
    UWF.unusualStatusesHidden = true;
    $('#status_switch').text('More statuses');
    $('#collapsed-statuses-holder').addClass('collapsed');
};


UWF.showUnusualStates = function (doAnim) {
    var animLength = false;
    if (doAnim) {
        animLength = UWF.ANIM_SPEED;
    }
    UWF.ALL_STATES.forEach(function (state) {
        $('#' + UWF.getCssName(state)).parent().show(animLength);
    });
    UWF.unusualStatusesHidden = false;
    $('#status_switch').text('Less statuses');
    $('#collapsed-statuses-holder').removeClass('collapsed');
};

UWF.toggleHideStatuses = function() {
    if (UWF.unusualStatusesHidden) {
        UWF.showUnusualStates(true);
    } else {
        UWF.hideUnusualStates(true);
    }
};

UWF.addSwitch = function () {
    $('fieldset#action legend').html('Status <span id="collapsed-statuses-holder" class="collapsed"><span class="foldable"><a id="status_switch" href="javascript:void(0)"> More statuses</a></span></span>');
    $('#status_switch').click(UWF.toggleHideStatuses);
};

$(document).ready(function() {
    console.log("Usual worflow is beign activated.");
    UWF.init();
    console.log("Usual worflow is active now.");
});
